#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <netdb.h>
#include <unistd.h>

#include "event.h"
#include "recorder.h"



int NCSrecorder::init()
{
  char *ncspath;
  char path[100];

  ncspath = getenv("NCS_PATH");
  strcpy(path, ncspath);
  strcat(path, "/recorder.data");
  first = 1;
  
  if((fd = open(path, O_WRONLY | O_CREAT | O_TRUNC, S_IRWXU)) < 0)
    {
      fprintf(stderr, "Recorder: file open error\n");
      exit(-1);
    }

  if((sock = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
    {
      fprintf(stderr, "Recorder: cannot open socket\n");
      return -1;
    }
  
  addr.sin_family = AF_INET;
  addr.sin_port = RECORDER_PORT;
  addr.sin_addr.s_addr = INADDR_ANY;
  
  if((bind(sock, &addr, sizeof(struct sockaddr_in))) < 0)
    {
      fprintf(stderr, "Recorder: bind error\n");
      return -1;
    }

  return 1;
}

void NCSrecorder::quit()
{
  close(sock);
  close(fd);
}


void NCSrecorder::run()
{
  fd_set set;
  struct timeval timeout;
  
  while(1)
    {
      timeout.tv_sec = 0;
      timeout.tv_usec = 100000;
      FD_ZERO(&set);
      FD_SET(sock, &set);
      if(select(sock+1, &set, 0, 0, &timeout) > 0)
	{
	  if(FD_ISSET(sock, &set))
	    {
	      event.receive(sock);
	      event.save(fd);
	    }
	}
    }
}


NCSrecorder recorder;

void quit()
{
  recorder.quit();
  exit(0);
}

void main(void)
{
  signal(SIGINT, quit);
  signal(SIGKILL, quit);
  recorder.init();
  recorder.run();
}



